## librime 1.4.0+dfsg1

=== CMakeLists.txt ===
set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)

project(rime)
cmake_minimum_required(VERSION 2.8.11)

set(rime_version 1.4.0)
set(rime_soversion 1)

add_definitions(-DRIME_VERSION="${rime_version}")

option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
option(BUILD_STATIC "Build with dependencies as static libraries" OFF)
option(BUILD_DATA "Build data for Rime" OFF)
option(BUILD_TEST "Build and run tests" ON)
option(BUILD_SEPARATE_LIBS "Build a separate rime-gears library" OFF)
option(ENABLE_LOGGING "Enable logging with google-glog library" ON)
option(BOOST_USE_CXX11 "Boost has been built with C++11 support" OFF)
option(BOOST_USE_SIGNALS2 "Boost use signals2 instead of signals" ON)
option(ENABLE_ASAN "Enable Address Sanitizer (Unix Only)" OFF)

set(rime_data_dir "/share/rime-data" CACHE STRING "Target directory for Rime data")

if(WIN32)
  set(ext ".exe")
endif(WIN32)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${PROJECT_SOURCE_DIR}/thirdparty")

if (ENABLE_ASAN)
  set(asan_cflags "-fsanitize=address -fno-omit-frame-pointer")
  set(asan_lflags "-fsanitize=address -lasan")
  set(CMAKE_C_FLAGS "${asan_cflags} ${CMAKE_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${asan_cflags} ${CMAKE_CXX_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${asan_lflags} ${CMAKE_EXE_LINKER_FLAGS}")
  set(CMAKE_SHARED_LINKER_FLAGS "${asan_lflags} ${CMAKE_SHARED_LINKER_FLAGS}")
endif()

set(Boost_USE_STATIC_LIBS ${BUILD_STATIC})
set(Gflags_STATIC ${BUILD_STATIC})
set(Glog_STATIC ${BUILD_STATIC})
set(LevelDb_STATIC ${BUILD_STATIC})
set(Marisa_STATIC ${BUILD_STATIC})
set(Opencc_STATIC ${BUILD_STATIC})
set(YamlCpp_STATIC ${BUILD_STATIC})

set(Boost_USE_MULTITHREADED ON)
if(MSVC)
  set(Boost_USE_STATIC_RUNTIME ON)
endif()

if(NOT BOOST_USE_CXX11)
  add_definitions("-DBOOST_NO_CXX11_SCOPED_ENUMS")
endif()

set(BOOST_COMPONENTS filesystem regex system locale)

if(BOOST_USE_SIGNALS2)
  add_definitions("-DBOOST_SIGNALS2")
else()
  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} singals)
endif()

find_package(Boost 1.46.0 REQUIRED COMPONENTS ${BOOST_COMPONENTS})
if(Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
  link_directories(${Boost_LIBRARY_DIRS})
endif()

if(ENABLE_LOGGING)

  find_package(Gflags)
  if(Gflags_FOUND)
    include_directories(${Gflags_INCLUDE_PATH})
  endif()

  find_package(Glog REQUIRED)
  if(Glog_FOUND)
    include_directories(${Glog_INCLUDE_PATH})
  endif()
  if(Glog_STATIC)
    add_definitions(-DGOOGLE_GLOG_DLL_DECL=)
  endif()

  add_definitions(-DRIME_ENABLE_LOGGING)

endif()

find_package(Threads)

find_package(Iconv)
if (ICONV_FOUND)
  include_directories(${ICONV_INCLUDE_DIRS})
endif()

if(BUILD_TEST)
  find_package(GTest REQUIRED)
  if(GTEST_FOUND)
    enable_testing()
    include_directories(${GTEST_INCLUDE_DIRS})
  endif()
endif()

find_package(YamlCpp REQUIRED)
if(YamlCpp_FOUND)
  include_directories(${YamlCpp_INCLUDE_PATH})
endif()

find_package(LevelDb REQUIRED)
if(LevelDb_FOUND)
    include_directories(${LevelDb_INCLUDE_PATH})
endif()

find_package(Marisa REQUIRED)
if(Marisa_FOUND)
  include_directories(${Marisa_INCLUDE_PATH})
endif()

find_package(Opencc REQUIRED)
if(Opencc_FOUND)
include_directories(${Opencc_INCLUDE_PATH})
endif()
if(Opencc_STATIC)
  add_definitions(-DOpencc_BUILT_AS_STATIC)
endif()

find_path(X11Keysym X11/keysym.h)
if(X11Keysym)
  message(STATUS "Found X11/keysym.h at ${X11Keysym}")
  include_directories(${X11Keysym})
else()
  message(WARNING "X11/keysym.h not found.")
endif()

include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include)
link_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib)

if(MSVC)
  if(MSVC10)
    # stdint.h is missing from VS2010
    include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include/msvc)
  endif()
  add_definitions("/wd4244 /wd4996")
endif()

if(UNIX)
  add_definitions("-std=c++11")
endif()

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
endif()

if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly")
  # uninstall target
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

  set(prefix "${CMAKE_INSTALL_PREFIX}")
  set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
  set(bindir "${exec_prefix}/bin")
  set(libdir "${LIB_INSTALL_DIR}")
  set(pkgdatadir "${prefix}${rime_data_dir}")
  set(includedir "${CMAKE_INSTALL_PREFIX}/include")
  configure_file(
      ${PROJECT_SOURCE_DIR}/rime.pc.in
      ${PROJECT_BINARY_DIR}/rime.pc
      @ONLY)
  file(GLOB installed_header_files ${PROJECT_SOURCE_DIR}/src/*.h)
  install(FILES ${installed_header_files} DESTINATION include)
  install(FILES ${PROJECT_BINARY_DIR}/rime.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
  install(FILES cmake/RimeConfig.cmake DESTINATION share/cmake/rime)

  if(BUILD_DATA)
    file(GLOB preset_data_files ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
    install(FILES ${preset_data_files} DESTINATION ${pkgdatadir})
  endif()
endif()

if(BUILD_SHARED_LIBS)
  add_definitions(-DRIME_BUILD_SHARED_LIBS)
  set(rime_library rime)
  if(BUILD_SEPARATE_LIBS)
    set(rime_gears_library rime-gears)
  endif()
else()
  set(rime_library rime-static)
  if(BUILD_SEPARATE_LIBS)
    set(rime_gears_library rime-gears-static)
  endif()
endif()

add_subdirectory(src)

if(BUILD_SHARED_LIBS)
  add_subdirectory(tools)

  if(GTEST_FOUND)
    add_subdirectory(test)
  endif()
endif()

=== Makefile ===
RIME_ROOT = $(CURDIR)

sharedir = $(DESTDIR)/usr/share
bindir = $(DESTDIR)/usr/bin

.PHONY: all thirdparty clean librime librime-static install-librime uninstall-librime release install uninstall debug install-debug uninstall-debug test

all: release

thirdparty:
	make -f Makefile.thirdparty

thirdparty/%:
	make -f Makefile.thirdparty $(@:thirdparty/%=%)

clean:
	rm -Rf build build-static debug-build

librime: release
install-librime: install
uninstall-librime: uninstall

librime-static:
	cmake . -Bbuild-static -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DBUILD_STATIC=ON -DBUILD_SHARED_LIBS=OFF
	cmake --build build-static

release:
	cmake . -Bbuild -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release
	cmake --build build

debug:
	cmake . -Bdebug-build -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Debug
	cmake --build debug-build

install:
	cmake --build build --target install

install-debug:
	cmake --build debug-build --target install

uninstall:
	cmake --build build --target uninstall

uninstall-debug:
	cmake --build debug-build --target uninstall

test: release
	(cd build/test; ./rime_test)

test-debug: debug
	(cd debug-build/test; ./rime_test)

=== sample/CMakeLists.txt ===
project(rime-sample)
cmake_minimum_required(VERSION 2.8)

set(SAMPLE_VERSION 1.0.0)
set(SAMPLE_SOVERSION 1)

option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
option(BUILD_STATIC "Build sample using static libraries" OFF)
option(BUILD_TEST "Build and run tests" ON)

if(WIN32)
  message(FATAL_ERROR "Plugins are not supported under Windows.")
endif(WIN32)

set(RIME_SOURCE_DIR ${PROJECT_SOURCE_DIR}/..)
set(CMAKE_MODULE_PATH ${RIME_SOURCE_DIR}/cmake)

set(Gflags_STATIC ${BUILD_STATIC})
set(Glog_STATIC ${BUILD_STATIC})

find_package(Rime REQUIRED)
if(Rime_FOUND)
  include_directories(${Rime_INCLUDE_DIR})
endif(Rime_FOUND)

find_package(Gflags)
if(Gflags_FOUND)
  include_directories(${Gflags_INCLUDE_PATH})
endif(Gflags_FOUND)

find_package(Glog REQUIRED)
if(Glog_FOUND)
  include_directories(${Glog_INCLUDE_PATH})
endif(Glog_FOUND)

if(BUILD_TEST)
  find_package(GTest REQUIRED)
if(GTEST_FOUND)
  enable_testing()
  include_directories(${GTEST_INCLUDE_DIRS})
endif(GTEST_FOUND)
endif(BUILD_TEST)

include_directories(${RIME_SOURCE_DIR}/include)
#include_directories(${RIME_SOURCE_DIR}/thirdparty/include)
#link_directories(${RIME_SOURCE_DIR}/thirdparty/lib)
if(UNIX)
  add_definitions("-std=c++11")
endif(UNIX)

add_subdirectory(src)
add_subdirectory(tools)
if(GTEST_FOUND)
  add_subdirectory(test)
endif(GTEST_FOUND)

=== src/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

aux_source_directory(. rime_src_api)
aux_source_directory(rime rime_src_base)
aux_source_directory(rime/algo rime_src_algo)
aux_source_directory(rime/config rime_src_config)
aux_source_directory(rime/dict rime_src_dict)
aux_source_directory(rime/gear rime_src_gear)
aux_source_directory(rime/lever rime_src_lever)

if(BUILD_SEPARATE_LIBS)
  set(rime_src
      ${rime_src_api}
      ${rime_src_base}
      ${rime_src_config})
  set(librime_gears_src
      ${rime_src_algo}
      ${rime_src_dict}
      ${rime_src_gear}
      ${rime_src_lever})
else()
  set(rime_src
      ${rime_src_api}
      ${rime_src_base}
      ${rime_src_algo}
      ${rime_src_config}
      ${rime_src_dict}
      ${rime_src_gear}
      ${rime_src_lever})
endif()

set(rime_optional_deps "")
if(Gflags_FOUND)
  set(rime_optional_deps ${rime_optional_deps} ${Gflags_LIBRARY})
endif()

set(rime_core_deps
    ${Boost_LIBRARIES}
    ${Glog_LIBRARY}
    ${YamlCpp_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    ${rime_optional_deps})
set(rime_extra_deps
    ${ICONV_LIBRARIES}
    ${LevelDb_LIBRARY}
    ${Marisa_LIBRARY}
    ${Opencc_LIBRARY})

if(MINGW)
  set(rime_core_deps ${rime_core_deps} wsock32 ws2_32)
endif()

if(BUILD_SEPARATE_LIBS)
  set(rime_deps ${rime_core_deps})
  set(rime_gears_deps ${rime_library} ${rime_extra_deps})
else()
  set(rime_deps ${rime_core_deps} ${rime_extra_deps})
endif()

if(BUILD_SHARED_LIBS)
  add_library(rime ${rime_src})
  target_link_libraries(rime ${rime_deps})
  set_target_properties(rime PROPERTIES DEFINE_SYMBOL "RIME_EXPORTS")
  set_target_properties(rime PROPERTIES VERSION ${rime_version} SOVERSION ${rime_soversion})
  if(XCODE_VERSION)
    set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
  endif()
  install(TARGETS rime DESTINATION ${LIB_INSTALL_DIR})
  if(BUILD_SEPARATE_LIBS)
    add_library(rime-gears ${librime_gears_src})
    target_link_libraries(rime-gears ${rime_gears_deps})
    add_dependencies(rime-gears ${rime_library})
    set_target_properties(rime-gears PROPERTIES VERSION ${rime_version} SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-gears PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-gears DESTINATION ${LIB_INSTALL_DIR})
  endif()
else()
  add_library(rime-static STATIC ${rime_src})
  target_link_libraries(rime-static ${rime_deps})
  set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
  install(TARGETS rime-static DESTINATION ${LIB_INSTALL_DIR})
  if(BUILD_SEPARATE_LIBS)
    add_library(rime-gears-static STATIC ${librime_gears_src})
    target_link_libraries(rime-gears-static ${rime_gears_deps})
    add_dependencies(rime-gears-static ${rime_library})
    set_target_properties(rime-gears-static PROPERTIES OUTPUT_NAME "rime-gears" PREFIX "lib")
    install(TARGETS rime-gears-static DESTINATION ${LIB_INSTALL_DIR})
  endif()
endif()

=== test/CMakeLists.txt ===
aux_source_directory(. rime_test_src)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/test)
add_executable(rime_test ${rime_test_src})
target_link_libraries(rime_test
                      ${rime_library} ${rime_gears_library}
                      ${GTEST_LIBRARIES})
if(BUILD_SHARED_LIBS)
  target_compile_definitions(rime_test PRIVATE RIME_IMPORTS)
endif(BUILD_SHARED_LIBS)
add_dependencies(rime_test ${rime_library} ${rime_gears_library})

file(GLOB test_data_files ${PROJECT_SOURCE_DIR}/data/test/*.yaml)
file(COPY ${test_data_files} DESTINATION ${EXECUTABLE_OUTPUT_PATH})

set(rime_test_executable ${EXECUTABLE_OUTPUT_PATH}/rime_test${ext})
add_test(rime_test ${rime_test_executable})

=== tools/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

set(rime_api_console_src "rime_api_console.cc")
add_executable(rime_api_console ${rime_api_console_src})
target_link_libraries(rime_api_console ${rime_library} ${rime_gears_library})
add_dependencies(rime_api_console ${rime_library} ${rime_gears_library})

set(rime_patch_src "rime_patch.cc")
add_executable(rime_patch ${rime_patch_src})
target_link_libraries(rime_patch ${rime_library} ${rime_gears_library})
add_dependencies(rime_patch ${rime_library} ${rime_gears_library})

# msvc doesn't export all symbols
if(NOT (WIN32 AND BUILD_SHARED_LIBS))

set(rime_console_src "rime_console.cc")
add_executable(rime_console ${rime_console_src})
target_link_libraries(rime_console ${rime_library} ${rime_gears_library})
add_dependencies(rime_console ${rime_library} ${rime_gears_library})

set(rime_dict_manager_src "rime_dict_manager.cc")
add_executable(rime_dict_manager ${rime_dict_manager_src})
target_link_libraries(rime_dict_manager ${rime_library} ${rime_gears_library})
add_dependencies(rime_dict_manager ${rime_library} ${rime_gears_library})

set(rime_deployer_src "rime_deployer.cc")
add_executable(rime_deployer ${rime_deployer_src})
target_link_libraries(rime_deployer ${rime_library} ${rime_gears_library})
add_dependencies(rime_deployer ${rime_library} ${rime_gears_library})

install(TARGETS rime_dict_manager DESTINATION ${BIN_INSTALL_DIR})
install(TARGETS rime_deployer DESTINATION ${BIN_INSTALL_DIR})

endif()

file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/default.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/symbols.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/essay.txt
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})

=== sample/src/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
aux_source_directory(. SAMPLE_SRC)
add_library(rime-sample ${SAMPLE_SRC})
target_link_libraries(rime-sample ${Rime_LIBRARIES})
set_target_properties(rime-sample PROPERTIES VERSION ${SAMPLE_VERSION} SOVERSION ${SAMPLE_SOVERSION})
if(XCODE_VERSION)
  set_target_properties(rime-sample PROPERTIES INSTALL_NAME_DIR "@rpath")
endif(XCODE_VERSION)

=== debian/changelog ===
librime (1.4.0+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Fix pkg-config libdir variable. (Closes: #921753)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 12 Feb 2019 01:50:40 +0800

librime (1.4.0+dfsg1-1) unstable; urgency=medium

  * New upstream release 1.4.0.
  * debian/watch: Repack upstream tarball on new release.
  * debian/patches:
    + Refresh patches.
    + Add patch to fix FTBFS on non-Linux platforms. (MR: !1)

 -- Boyuan Yang <byang@debian.org>  Mon, 21 Jan 2019 12:52:16 -0500

librime (1.3.2+dfsg1-2) unstable; urgency=medium

  * Rebuild for libyaml-cpp0.6 transition.
  * debian/control:
    + Build-depend on debhelper-compat (= 12) instead of using
      debian/compat file.
    + Bump Standards-Version to 4.3.0.

 -- Boyuan Yang <byang@debian.org>  Tue, 08 Jan 2019 09:22:35 -0500

librime (1.3.2+dfsg1-1) unstable; urgency=medium

  * New upstream release 1.3.2.
  * Rebuild for libboost1.67 transition.
  * debian/control:
    + Explicitly add versioned build-dependency on libyaml-cpp-dev
      (>= 0.5.2-4.1~) to prevent building against broken yaml-cpp
      packages.
  * debian/watch:
    + Update to v4 format, update watch URL.
  * debian/copyright:
    + Update Files-Excluded list.
  * debian/patches:
    + Refresh patches, drop patches applied upstream.

 -- Boyuan Yang <byang@debian.org>  Mon, 19 Nov 2018 21:08:11 -0500

librime (1.3.1+dfsg1-2) unstable; urgency=medium

  * Rebuild against gcc 8.
  * debian/control:
    + Update uploader info and use the @debian.org email address.
    + Bump Standards-Version to 4.2.1 (no changes needed).
    + Update Vcs-* fields and use the repo under Salsa Input Method Team.

 -- Boyuan Yang <byang@debian.org>  Fri, 31 Aug 2018 23:44:00 -0400

=== debian/control ===
Source: librime
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Qijiang Fan <fqj1994@gmail.com>,
 Aron Xu <aron@debian.org>,
 YunQiang Su <syq@debian.org>,
 Osamu Aoki <osamu@debian.org>,
 Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>,
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.0.2),
 debhelper-compat (= 12),
 libboost-dev,
 libboost-filesystem-dev,
 libboost-locale-dev,
 libboost-regex-dev,
 libboost-signals-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libgoogle-glog-dev,
 libleveldb-dev,
 libmarisa-dev,
 libopencc-dev (>= 1.0.1),
 libyaml-cpp-dev (>= 0.5.2-4.1~),
 x11proto-core-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.3.0
Homepage: https://github.com/rime/librime
Vcs-Git: https://salsa.debian.org/input-method-team/librime.git
Vcs-Browser: https://salsa.debian.org/input-method-team/librime

Package: librime-bin
Architecture: any
Depends:
 librime1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 librime-data (>= 0.38),
Description: Rime Input Method Engine - utilities
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the executable utilities of RIME.
Section: utils

Package: librime-dev
Architecture: any
Section: libdevel
Depends:
 librime1 (<< ${source:Upstream-Version}.0~),
 librime1 (>= ${source:Version}),
 ${misc:Depends},
Provides:
 librime1-dev,
Conflicts:
 librime1-dev,
Replaces:
 librime1-dev,
Description: Rime Input Method Engine, the core library - development files
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the development files of RIME.

Package: librime1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Recommends:
 librime-bin,
 librime-data (>= 0.38),
Description: Rime Input Method Engine - core library
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the core library of RIME.

=== debian/rules ===
#!/usr/bin/make -f

# See dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -Scmake -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DBOOST_USE_CXX11=ON \
	    -DBUILD_TEST=OFF

override_dh_strip:
	dh_strip --dbgsym-migration='librime1-dbg (<< 1.2.9+dfsg1-1~)'

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md

## librime 1.5.2+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,16 +4,18 @@
 project(rime)
 cmake_minimum_required(VERSION 2.8.11)
 
-set(rime_version 1.4.0)
+set(rime_version 1.5.2)
 set(rime_soversion 1)
 
 add_definitions(-DRIME_VERSION="${rime_version}")
 
 option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
+option(BUILD_MERGED_PLUGINS "Merge plugins into one Rime library" ON)
 option(BUILD_STATIC "Build with dependencies as static libraries" OFF)
 option(BUILD_DATA "Build data for Rime" OFF)
+option(BUILD_SAMPLE "Build sample Rime plugin" OFF)
 option(BUILD_TEST "Build and run tests" ON)
-option(BUILD_SEPARATE_LIBS "Build a separate rime-gears library" OFF)
+option(BUILD_SEPARATE_LIBS "Build separate rime-* libraries" OFF)
 option(ENABLE_LOGGING "Enable logging with google-glog library" ON)
 option(BOOST_USE_CXX11 "Boost has been built with C++11 support" OFF)
 option(BOOST_USE_SIGNALS2 "Boost use signals2 instead of signals" ON)
@@ -142,11 +144,12 @@
     # stdint.h is missing from VS2010
     include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include/msvc)
   endif()
-  add_definitions("/wd4244 /wd4996")
+  # Force Boost.Uuid to use wincrypt as random provider instead of bcrypt for Windows XP compatibility
+  add_definitions("/wd4244 /wd4996 /DBOOST_UUID_RANDOM_PROVIDER_FORCE_WINCRYPT")
 endif()
 
 if(UNIX)
-  add_definitions("-std=c++11")
+  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 endif()
 
 if(NOT DEFINED LIB_INSTALL_DIR)
@@ -157,15 +160,15 @@
     set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
 endif()
 
+# uninstall target
+configure_file(
+  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
+  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+  IMMEDIATE @ONLY)
+add_custom_target(uninstall
+  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
+
 if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly")
-  # uninstall target
-  configure_file(
-    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
-    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-    IMMEDIATE @ONLY)
-  add_custom_target(uninstall
-    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
-
   set(prefix "${CMAKE_INSTALL_PREFIX}")
   set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
   set(bindir "${exec_prefix}/bin")
@@ -176,28 +179,43 @@
       ${PROJECT_SOURCE_DIR}/rime.pc.in
       ${PROJECT_BINARY_DIR}/rime.pc
       @ONLY)
-  file(GLOB installed_header_files ${PROJECT_SOURCE_DIR}/src/*.h)
-  install(FILES ${installed_header_files} DESTINATION include)
-  install(FILES ${PROJECT_BINARY_DIR}/rime.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
-  install(FILES cmake/RimeConfig.cmake DESTINATION share/cmake/rime)
-
-  if(BUILD_DATA)
-    file(GLOB preset_data_files ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
-    install(FILES ${preset_data_files} DESTINATION ${pkgdatadir})
-  endif()
+  install(FILES ${PROJECT_BINARY_DIR}/rime.pc
+    DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
+endif()
+
+install(FILES cmake/RimeConfig.cmake DESTINATION share/cmake/rime)
+
+file(GLOB rime_public_header_files ${PROJECT_SOURCE_DIR}/src/*.h)
+install(FILES ${rime_public_header_files} DESTINATION include)
+
+if(BUILD_DATA)
+  file(GLOB rime_preset_data_files ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
+  install(FILES ${rime_preset_data_files}
+    DESTINATION ${CMAKE_INSTALL_PREFIX}${rime_data_dir})
 endif()
 
 if(BUILD_SHARED_LIBS)
   add_definitions(-DRIME_BUILD_SHARED_LIBS)
   set(rime_library rime)
   if(BUILD_SEPARATE_LIBS)
+    set(rime_dict_library rime-dict)
     set(rime_gears_library rime-gears)
+    set(rime_levers_library rime-levers)
   endif()
 else()
   set(rime_library rime-static)
-  if(BUILD_SEPARATE_LIBS)
-    set(rime_gears_library rime-gears-static)
-  endif()
+endif()
+
+add_subdirectory(plugins)
+message(STATUS "rime_plugins_libs: ${rime_plugins_deps}")
+message(STATUS "rime_plugins_modules: ${rime_plugins_modules}")
+set(list "")
+foreach(mod ${rime_plugins_modules})
+  set(list "${list},Q(${mod})")
+endforeach()
+add_definitions(-DRIME_EXTRA_MODULES=${list})
+if(BUILD_SHARED_LIBS AND BUILD_SEPARATE_LIBS AND rime_plugins_objs)
+  set(rime_plugins_library rime-plugins)
 endif()
 
 add_subdirectory(src)
@@ -205,7 +223,11 @@
 if(BUILD_SHARED_LIBS)
   add_subdirectory(tools)
 
-  if(GTEST_FOUND)
+  if(BUILD_TEST)
     add_subdirectory(test)
   endif()
-endif()
+
+  if (BUILD_SAMPLE)
+    add_subdirectory(sample)
+  endif()
+endif()

=== src/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

aux_source_directory(. rime_api_src)
aux_source_directory(rime rime_base_src)
aux_source_directory(rime/algo rime_algo_src)
aux_source_directory(rime/config rime_config_src)
aux_source_directory(rime/dict rime_dict_src)
aux_source_directory(rime/gear rime_gears_src)
aux_source_directory(rime/lever rime_levers_src)
if(rime_plugins_library)
  aux_source_directory(../plugins rime_plugins_src)
endif()

set(rime_core_module_src
  ${rime_api_src}
  ${rime_base_src}
  ${rime_config_src})
set(rime_dict_module_src
  ${rime_algo_src}
  ${rime_dict_src})

if(BUILD_SHARED_LIBS AND BUILD_SEPARATE_LIBS)
  set(rime_src ${rime_core_module_src})
else()
  set(rime_src
      ${rime_core_module_src}
      ${rime_dict_module_src}
      ${rime_gears_src}
      ${rime_levers_src}
      ${rime_plugins_src}
      ${rime_plugins_objs})
endif()

set(rime_optional_deps "")
if(Gflags_FOUND)
  set(rime_optional_deps ${rime_optional_deps} ${Gflags_LIBRARY})
endif()

set(rime_core_deps
    ${Boost_LIBRARIES}
    ${Glog_LIBRARY}
    ${YamlCpp_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    ${rime_optional_deps})
set(rime_dict_deps
    ${LevelDb_LIBRARY}
    ${Marisa_LIBRARY})
set(rime_gears_deps
    ${ICONV_LIBRARIES}
    ${Opencc_LIBRARY})
set(rime_levers_deps "")

if(MINGW)
  set(rime_core_deps ${rime_core_deps} wsock32 ws2_32)
endif()

if(BUILD_SEPARATE_LIBS)
  set(rime_deps ${rime_core_deps})
else()
  set(rime_deps
    ${rime_core_deps}
    ${rime_dict_deps}
    ${rime_gears_deps}
    ${rime_levers_deps}
    ${rime_plugins_deps})
endif()

if(BUILD_SHARED_LIBS)
  add_library(rime ${rime_src})
  target_link_libraries(rime ${rime_deps})
  set_target_properties(rime PROPERTIES
    DEFINE_SYMBOL "RIME_EXPORTS"
    VERSION ${rime_version}
    SOVERSION ${rime_soversion})
  if(XCODE_VERSION)
    set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
  endif()
  install(TARGETS rime DESTINATION ${LIB_INSTALL_DIR})

  if(BUILD_SEPARATE_LIBS)
    add_library(rime-dict ${rime_dict_module_src})
    target_link_libraries(rime-dict
      ${rime_dict_deps}
      ${rime_library})
    set_target_properties(rime-dict PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-dict PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-dict DESTINATION ${LIB_INSTALL_DIR})

    add_library(rime-gears ${rime_gears_src})
    target_link_libraries(rime-gears
      ${rime_gears_deps}
      ${rime_library}
      ${rime_dict_library})
    set_target_properties(rime-gears PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-gears PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-gears DESTINATION ${LIB_INSTALL_DIR})

    add_library(rime-levers ${rime_levers_src})
    target_link_libraries(rime-levers
      ${rime_levers_deps}
      ${rime_library}
      ${rime_dict_library})
    set_target_properties(rime-levers PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-levers PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-levers DESTINATION ${LIB_INSTALL_DIR})

    if(rime_plugins_library)
      add_library(rime-plugins
        ${rime_plugins_src}
        ${rime_plugins_objs})
      target_link_libraries(rime-plugins
        ${rime_plugins_deps}
        ${rime_library}
        ${rime_dict_library}
        ${rime_gears_library})
      set_target_properties(rime-plugins PROPERTIES
        VERSION ${rime_version}
        SOVERSION ${rime_soversion})
      if(XCODE_VERSION)
        set_target_properties(rime-plugins PROPERTIES INSTALL_NAME_DIR "@rpath")
      endif()
      install(TARGETS rime-plugins DESTINATION ${LIB_INSTALL_DIR})
    endif()
  endif()
else()
  add_library(rime-static STATIC ${rime_src})
  target_link_libraries(rime-static ${rime_deps})
  set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
  install(TARGETS rime-static DESTINATION ${LIB_INSTALL_DIR})
endif()

=== debian/changelog ===
librime (1.5.2+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release 1.5.2.

 -- Boyuan Yang <byang@debian.org>  Fri, 21 Jun 2019 14:03:03 -0400

## librime 1.5.3+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 project(rime)
 cmake_minimum_required(VERSION 2.8.11)
 
-set(rime_version 1.5.2)
+set(rime_version 1.5.3)
 set(rime_soversion 1)
 
 add_definitions(-DRIME_VERSION="${rime_version}")
@@ -20,6 +20,7 @@
 option(BOOST_USE_CXX11 "Boost has been built with C++11 support" OFF)
 option(BOOST_USE_SIGNALS2 "Boost use signals2 instead of signals" ON)
 option(ENABLE_ASAN "Enable Address Sanitizer (Unix Only)" OFF)
+option(BUILD_WITH_ICU "Build by explicitly linking to ICU libraries" OFF)
 
 set(rime_data_dir "/share/rime-data" CACHE STRING "Target directory for Rime data")
 
@@ -90,6 +91,10 @@
 endif()
 
 find_package(Threads)
+
+if (BUILD_WITH_ICU)
+  find_package(ICU COMPONENTS uc)
+endif()
 
 find_package(Iconv)
 if (ICONV_FOUND)

=== Makefile ===
RIME_ROOT = $(CURDIR)

sharedir = $(DESTDIR)/usr/share
bindir = $(DESTDIR)/usr/bin

.PHONY: all thirdparty xcode clean\
librime librime-static install-librime uninstall-librime \
release debug test install uninstall install-debug uninstall-debug

all: release

thirdparty:
	make -f thirdparty.mk

thirdparty/%:
	make -f thirdparty.mk $(@:thirdparty/%=%)

xcode:
	make -f xcode.mk

xcode/%:
	make -f xcode.mk $(@:xcode/%=%)

clean:
	rm -Rf build build-static debug

librime: release
install-librime: install
uninstall-librime: uninstall

librime-static:
	cmake . -Bbuild-static \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_STATIC=ON \
	-DBUILD_SHARED_LIBS=OFF
	cmake --build build-static

release:
	cmake . -Bbuild \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_MERGED_PLUGINS=OFF
	cmake --build build

merged-plugins:
	cmake . -Bbuild \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_MERGED_PLUGINS=ON
	cmake --build build

debug:
	cmake . -Bdebug \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Debug
	cmake --build debug

install:
	cmake --build build --target install

install-debug:
	cmake --build debug --target install

uninstall:
	cmake --build build --target uninstall

uninstall-debug:
	cmake --build debug --target uninstall

test: release
	(cd build/test; ./rime_test)

test-debug: debug
	(cd debug/test; ./rime_test)

=== plugins/CMakeLists.txt ===
set(RIME_SOURCE_DIR ${PROJECT_SOURCE_DIR})
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# work around CMake build issues on macOS
aux_source_directory(. rime_plugins_src)

unset(plugins_objs)
unset(plugins_deps)
unset(plugins_modules)
file(GLOB plugin_files "*")
foreach(file ${plugin_files})
  if (IS_DIRECTORY ${file})
    message(STATUS "Found plugin: ${file}")
    unset(plugin_name)
    unset(plugin_objs)
    unset(plugin_deps)
    unset(plugin_modules)
    add_subdirectory(${file})
    if(BUILD_MERGED_PLUGINS)
      set(plugins_objs ${plugins_objs} ${plugin_objs})
      set(plugins_deps ${plugins_deps} ${plugin_deps})
      set(plugins_modules ${plugins_modules} ${plugin_modules})
    else()
      message(STATUS "Plugin ${plugin_name} provides modules: ${plugin_modules}")
      add_library(${plugin_name} ${rime_plugins_src} ${plugin_objs})
      target_link_libraries(${plugin_name} ${plugin_deps})
      if(XCODE_VERSION)
	set_target_properties(${plugin_name} PROPERTIES INSTALL_NAME_DIR "@rpath")
      endif(XCODE_VERSION)
      install(TARGETS ${plugin_name} DESTINATION ${LIB_INSTALL_DIR})
    endif()
  endif()
endforeach(file)

set(rime_plugins_objs ${plugins_objs} PARENT_SCOPE)
set(rime_plugins_deps ${plugins_deps} PARENT_SCOPE)
set(rime_plugins_modules ${plugins_modules} PARENT_SCOPE)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,7 @@
     ${Marisa_LIBRARY})
 set(rime_gears_deps
     ${ICONV_LIBRARIES}
+    ${ICU_LIBRARIES}
     ${Opencc_LIBRARY})
 set(rime_levers_deps "")

=== test/CMakeLists.txt ===
aux_source_directory(. rime_test_src)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/test)
add_executable(rime_test ${rime_test_src})
target_link_libraries(rime_test
  ${rime_library}
  ${rime_dict_library}
  ${rime_gears_library}
  ${GTEST_LIBRARIES})
if(BUILD_SHARED_LIBS)
  target_compile_definitions(rime_test PRIVATE RIME_IMPORTS)
endif(BUILD_SHARED_LIBS)

file(GLOB test_data_files ${PROJECT_SOURCE_DIR}/data/test/*.yaml)
file(COPY ${test_data_files} DESTINATION ${EXECUTABLE_OUTPUT_PATH})

set(rime_test_executable ${EXECUTABLE_OUTPUT_PATH}/rime_test${ext})
add_test(rime_test ${rime_test_executable})

=== tools/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

set(rime_api_console_src "rime_api_console.cc")
add_executable(rime_api_console ${rime_api_console_src})
target_link_libraries(rime_api_console
  ${rime_library}
  ${rime_dict_library}
  ${rime_gears_library}
  ${rime_levers_library}
  ${rime_plugins_library})

set(rime_patch_src "rime_patch.cc")
add_executable(rime_patch ${rime_patch_src})
target_link_libraries(rime_patch
  ${rime_library}
  ${rime_levers_library})

# msvc doesn't export all symbols
if(NOT (WIN32 AND BUILD_SHARED_LIBS))

set(rime_console_src "rime_console.cc")
add_executable(rime_console ${rime_console_src})
target_link_libraries(rime_console
  ${rime_library}
  ${rime_dict_library}
  ${rime_gears_library}
  ${rime_levers_library}
  ${rime_plugins_library})

set(rime_dict_manager_src "rime_dict_manager.cc")
add_executable(rime_dict_manager ${rime_dict_manager_src})
target_link_libraries(rime_dict_manager
  ${rime_library}
  ${rime_dict_library}
  ${rime_levers_library})

set(rime_deployer_src "rime_deployer.cc")
add_executable(rime_deployer ${rime_deployer_src})
target_link_libraries(rime_deployer
  ${rime_library}
  ${rime_dict_library}
  ${rime_levers_library})

install(TARGETS rime_dict_manager DESTINATION ${BIN_INSTALL_DIR})
install(TARGETS rime_deployer DESTINATION ${BIN_INSTALL_DIR})

endif()

file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/default.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/symbols.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/essay.txt
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/luna_pinyin.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.dict.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})
file(COPY ${PROJECT_SOURCE_DIR}/data/minimal/cangjie5.schema.yaml
     DESTINATION ${EXECUTABLE_OUTPUT_PATH})

=== thirdparty/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

# libmarisa

# Official repo: https://github.com/s-yata/marisa-trie
# CMake script borrowed from https://github.com/Karry/osmscout-sailfish/blob/master/CMakeLists.txt

# libmarisa don't have cmake based build, but it is relatively small,
# so we define library target here

if(UNIX)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Weffc++ -Wextra -Wconversion")
endif()

set(MARISA_ROOT ${CMAKE_HOME_DIRECTORY}/marisa-trie)

set(MARISA_INCLUDE_DIRS
    ${MARISA_ROOT}/lib
    ${MARISA_ROOT}/include)

set(MARISA_SRC
    ${MARISA_ROOT}/lib/marisa/grimoire/io/reader.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/io/mapper.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/io/writer.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/trie/tail.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/trie/louds-trie.cc
    ${MARISA_ROOT}/lib/marisa/grimoire/vector/bit-vector.cc
    ${MARISA_ROOT}/lib/marisa/trie.cc
    ${MARISA_ROOT}/lib/marisa/agent.cc
    ${MARISA_ROOT}/lib/marisa/keyset.cc
)

include_directories(
  ${MARISA_INCLUDE_DIRS}
)

add_library(marisa
    ${MARISA_SRC}
)

install(TARGETS marisa
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

set(include_headers ${MARISA_ROOT}/include/marisa.h)
file(GLOB libmarisa_include_headers ${MARISA_ROOT}/include/marisa/*.h)
install(FILES ${include_headers} DESTINATION include)
install(FILES ${libmarisa_include_headers} DESTINATION include/marisa)

=== debian/changelog ===
librime (1.5.3+dfsg1-4build3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:54:29 +0100

librime (1.5.3+dfsg1-4build2) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:21:33 +0100

librime (1.5.3+dfsg1-4build1) focal; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 19:01:54 +0000

librime (1.5.3+dfsg1-4) unstable; urgency=medium

  * debian/control:
    + Bump Standards-Version to 4.5.0.
    - Drop build-dependency on libboost-signals-dev. This is no
      longer needed since librime 1.3.2. (Closes: #951221)
    + Mark package librime-dev as Multi-Arch: same.

 -- Boyuan Yang <byang@debian.org>  Wed, 12 Feb 2020 14:27:18 -0500

librime (1.5.3+dfsg1-3) unstable; urgency=high

  * debian/patches/0010: Add patch for CMakeLists.txt to properly
    generate pkgconfig file with absolute path. (Closes: #946741)

 -- Boyuan Yang <byang@debian.org>  Sun, 15 Dec 2019 13:15:08 -0500

librime (1.5.3+dfsg1-2) unstable; urgency=high

  * Team upload.
  * debian/patches/0009: Add patch for CMakeLists.txt to properly
    support GNU/Hurd.

 -- Boyuan Yang <byang@debian.org>  Sat, 14 Dec 2019 12:36:57 -0500

librime (1.5.3+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release 1.5.3.
  * debian/control: Bump Standards-Version to 4.4.1.
  * debian/patches: Backport upstream patches till 2019-12-12.
  * debian/librime1.shlibs: Bump minimum compat version to
    be 1.5.3.
  * d/s/lintian-overrides: Removed, useless now.

 -- Boyuan Yang <byang@debian.org>  Sat, 14 Dec 2019 10:35:24 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: librime
 Section: libs
 Priority: optional
-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders:
  Qijiang Fan <fqj1994@gmail.com>,
  Aron Xu <aron@debian.org>,
@@ -16,7 +17,6 @@
  libboost-filesystem-dev,
  libboost-locale-dev,
  libboost-regex-dev,
- libboost-signals-dev,
  libboost-system-dev,
  libboost-thread-dev,
  libgoogle-glog-dev,
@@ -27,7 +27,7 @@
  x11proto-core-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/rime/librime
 Vcs-Git: https://salsa.debian.org/input-method-team/librime.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/librime
@@ -55,6 +55,7 @@
 
 Package: librime-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends:
  librime1 (<< ${source:Upstream-Version}.0~),

=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,6 @@
 	    -DBOOST_USE_CXX11=ON \
 	    -DBUILD_TEST=OFF
 
-override_dh_strip:
-	dh_strip --dbgsym-migration='librime1-dbg (<< 1.2.9+dfsg1-1~)'
-
 override_dh_missing:
 	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d?$//,compression=xz,repack,repacksuffix=+dfsg1" \
 https://github.com/rime/librime/tags .*/(\d[\d\.]+)\.tar\.gz debian uupdate

## librime 1.5.3+git20200621+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,14 @@
 set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)
 
 project(rime)
-cmake_minimum_required(VERSION 2.8.11)
+cmake_minimum_required(VERSION 3.0.2)
 
 set(rime_version 1.5.3)
 set(rime_soversion 1)
 
 add_definitions(-DRIME_VERSION="${rime_version}")
+
+include(GNUInstallDirs)
 
 option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
 option(BUILD_MERGED_PLUGINS "Merge plugins into one Rime library" ON)
@@ -20,7 +22,6 @@
 option(BOOST_USE_CXX11 "Boost has been built with C++11 support" OFF)
 option(BOOST_USE_SIGNALS2 "Boost use signals2 instead of signals" ON)
 option(ENABLE_ASAN "Enable Address Sanitizer (Unix Only)" OFF)
-option(BUILD_WITH_ICU "Build by explicitly linking to ICU libraries" OFF)
 
 set(rime_data_dir "/share/rime-data" CACHE STRING "Target directory for Rime data")
 
@@ -57,12 +58,12 @@
   add_definitions("-DBOOST_NO_CXX11_SCOPED_ENUMS")
 endif()
 
-set(BOOST_COMPONENTS filesystem regex system locale)
+set(BOOST_COMPONENTS filesystem regex system)
 
 if(BOOST_USE_SIGNALS2)
   add_definitions("-DBOOST_SIGNALS2")
 else()
-  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} singals)
+  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} signals)
 endif()
 
 find_package(Boost 1.46.0 REQUIRED COMPONENTS ${BOOST_COMPONENTS})
@@ -91,15 +92,6 @@
 endif()
 
 find_package(Threads)
-
-if (BUILD_WITH_ICU)
-  find_package(ICU COMPONENTS uc)
-endif()
-
-find_package(Iconv)
-if (ICONV_FOUND)
-  include_directories(${ICONV_INCLUDE_DIRS})
-endif()
 
 if(BUILD_TEST)
   find_package(GTest REQUIRED)
@@ -145,6 +137,9 @@
 link_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib)
 
 if(MSVC)
+  # https://stackoverflow.com/a/31264946
+  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi")
+  set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
   if(MSVC10)
     # stdint.h is missing from VS2010
     include_directories(${PROJECT_SOURCE_DIR}/thirdparty/include/msvc)
@@ -158,11 +153,11 @@
 endif()
 
 if(NOT DEFINED LIB_INSTALL_DIR)
-    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
+    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
 endif()
 
 if(NOT DEFINED BIN_INSTALL_DIR)
-    set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
+    set(BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
 endif()
 
 # uninstall target
@@ -173,13 +168,13 @@
 add_custom_target(uninstall
   COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly")
+if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly|GNU")
   set(prefix "${CMAKE_INSTALL_PREFIX}")
   set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
-  set(bindir "${exec_prefix}/bin")
-  set(libdir "${LIB_INSTALL_DIR}")
+  set(bindir "${exec_prefix}/${BIN_INSTALL_DIR}")
+  set(libdir "${exec_prefix}/${LIB_INSTALL_DIR}")
   set(pkgdatadir "${prefix}${rime_data_dir}")
-  set(includedir "${CMAKE_INSTALL_PREFIX}/include")
+  set(includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
   configure_file(
       ${PROJECT_SOURCE_DIR}/rime.pc.in
       ${PROJECT_BINARY_DIR}/rime.pc

=== debian/changelog ===
librime (1.5.3+git20200621+dfsg1-1build2) groovy; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu67

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 Jul 2020 19:20:37 +0000

librime (1.5.3+git20200621+dfsg1-1build1) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:42:48 +0100

librime (1.5.3+git20200621+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sat, 04 Jul 2020 11:39:21 -0400

librime (1.5.3+git20200621+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream snapshot.
    + Support opencc 1.1.
  * debian/patches: Drop all patches, merged upstream.
  * Enforce package dependency with opencc 1.1+.
  * debian/shlibs: Bump version requirement accordingly.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Jul 2020 19:56:40 -0400

librime (1.5.3+dfsg1-6) unstable; urgency=high

  * Another rebuild to deal with the ABI compatibility issue
    with libyaml-cpp.
  * debian/control:
    + Conflicts with libopencc-dev (>= 1.1.0~) since there are
      binary incompatibilities. Upstream trunk has corresponding
      fixes that needs to be cherry-picked later.
    + Add Breaks relationship for binary packages as well.
    + Bump versioned build-dependency for libyaml-cpp-dev to be
      (>= 0.6.3-7~) to enforce the rebuild.
  * debian/rules: Drop useless dh_missing override.

 -- Boyuan Yang <byang@debian.org>  Thu, 14 May 2020 15:37:31 -0400

librime (1.5.3+dfsg1-5) unstable; urgency=medium

  * debian/control:
    + Bump debhelper compat to v13.
    + Force rebuild with opencc 1.0.6+. (Closes: #959223)
  * debian/librime1.shlibs: Bump minimal library version to
    1.5.3+dfsg1-5~ to avoid potential ABI incompatibility cased
    by the rebuild.
  * debian/rules: Drop as-needed linker flag, not longer needed.

 -- Boyuan Yang <byang@debian.org>  Sat, 02 May 2020 10:26:39 -0400

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
  cmake (>= 3.0.2),
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libboost-dev,
  libboost-filesystem-dev,
  libboost-locale-dev,
@@ -22,8 +22,8 @@
  libgoogle-glog-dev,
  libleveldb-dev,
  libmarisa-dev,
- libopencc-dev (>= 1.0.1),
- libyaml-cpp-dev (>= 0.5.2-4.1~),
+ libopencc-dev (>= 1.1~),
+ libyaml-cpp-dev (>= 0.6.3-7~),
  x11proto-core-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
